diff -r -c -b -B -N cosmomc/source/params.ini cosmomc_addon/source/params.ini
*** cosmomc/source/params.ini	1970-01-01 01:00:00.000000000 +0100
--- cosmomc_addon/source/params.ini	2009-10-27 18:28:07.281067670 +0100
***************
*** 0 ****
--- 1,190 ----
+ #Sample parameters for cosmomc in default parameterization
+ 
+ #Root name for files produced
+ file_root = chains/test
+ 
+ #action = 0:  MCMC, action=1: postprocess .data file, action=2: find best fit point only
+ action = 0
+ 
+ #Maximum number of chain steps
+ samples = 200000
+ 
+ #Feedback level ( 2=lots,1=chatty,0=none)
+ feedback = 1
+ 
+ #Temperature at which to Monte-Carlo
+ temperature = 1
+ 
+ #filenames for CMB datasets and SZ templates (added to C_l times parameter(13))
+ #Note you may need to change lmax in cmbtypes.f90 to use small scales (e.g. lmax=2100)
+ cmb_numdatasets = 1
+ cmb_dataset1 = WMAP
+ cmb_dataset_SZ1 = data/WMAP_SZ_VBand.dat
+ cmb_dataset_SZ_scale1 = 1
+ 
+ cmb_dataset2 = data/acbar2007_v3_corr.newdat
+ cmb_dataset_SZ2 = data/WMAP_SZ_VBand.dat
+ cmb_dataset_SZ_scale2 = 0.28
+ 
+ cmb_dataset3 = data/CBIpol_2.0_final.newdat
+ cmb_dataset4 = data/B03_NA_21July05.newdat
+ 
+ #filenames for matter power spectrum datasets, incl twodf
+ mpk_numdatasets = 1
+ mpk_dataset1 = data/lrgDR7kmax02kmin02newmaxLv2ALL_MAGCOVv3.dataset
+ #mpk_dataset1 = data/sdss_lrgDR4.dataset
+ #mpk_dataset1 = data/2df_2005.dataset
+ 
+ #filename for supernovae (default SDSS compilation)
+ SN_filename = data/supernovae.dataset
+ 
+ #if true, use HALOFIT for non-linear corrections (astro-ph/0207664).
+ #note lyman-alpha (lya) code assumes linear spectrum
+ nonlinear_pk = F
+ 
+ use_CMB = T
+ use_HST = F
+ use_mpk = F
+ use_bao = F
+ use_clusters = F
+ use_BBN = F
+ use_Age_Tophat_Prior = T
+ use_SN = F
+ use_lya = F
+ use_min_zre = 0
+ 
+ #directory, e.g. window functions in directory windows under data_dir
+ data_dir = data/
+ 
+ #Force computation of sigma_8 even if use_mpk = F
+ get_sigma8 = F
+ 
+ #1: Simple Metropolis, 2: slice sampling, 3: slice sampling fast parameters, 4: directional gridding
+ sampling_method = 1
+ 
+ #if sampling_method =4, iterations per gridded direction
+ directional_grid_steps = 20
+ 
+ #use fast-slow parameter distinctions to speed up 
+ #(note for basic models WMAP3 code is only ~3x as fast as CAMB)
+ use_fast_slow = F
+ 
+ #Can use covariance matrix for proposal density, otherwise use settings below
+ #Covariance matrix can be produced using "getdist" program.
+ propose_matrix = params_CMB.covmat
+ 
+ #If propose_matrix is blank (first run), can try to use numerical Hessian to 
+ #estimate a good propose matrix. As a byproduct you also get an approx best fit point
+ estimate_propose_matrix = F
+ 
+ #Tolerance on log likelihood to use when estimating best fit point
+ delta_loglike = 2
+ 
+ #Scale of proposal relative to covariance; 2.4 is recommended by astro-ph/0405462 for Gaussians
+ #If propose_matrix is much broader than the new distribution, make proportionately smaller
+ #Generally make smaller if your acceptance rate is too low
+ propose_scale = 2.4
+ 
+ #Increase to oversample fast parameters more, e.g. if space is odd shape
+ oversample_fast = 1
+ 
+ #if non-zero number of steps between sample info dumped to file file_root.data
+ indep_sample = 0
+ 
+ #number of samples to disgard at start; usually set to zero and remove later
+ burn_in = 0
+ 
+ #If zero set automatically
+ num_threads = 0
+ 
+ #MPI mode multi-chain options (recommended)
+ #MPI_Converge_Stop is a (variance of chain means)/(mean of variances) parameter that can be used to stop the chains
+ #Set to a negative number not to use this feature. Does not guarantee good accuracy of confidence limits.
+ MPI_Converge_Stop = 0.03
+ 
+ #Do initial period of slice sampling; may be good idea if 
+ #cov matrix or widths are likely to be very poor estimates
+ MPI_StartSliceSampling  = F
+ 
+ #Can optionally also check for convergence of confidence limits (after MPI_Converge_Stop reached)
+ #Can be good idea as small value of MPI_Converge_Stop does not (necessarily) imply good exploration of tails
+ MPI_Check_Limit_Converge = F
+ 
+ #if MPI_Check_Limit_Converge = T, give tail fraction to check (checks both tails):
+ MPI_Limit_Converge = 0.025
+ #permitted quantile chain variance in units of the standard deviation (small values v slow):
+ MPI_Limit_Converge_Err = 0.2
+ #which parameter's tails to check. If zero, check all parameters:
+ MPI_Limit_Param = 0
+ 
+ #if MPI_LearnPropose = T, the proposal density is continally updated from the covariance of samples so far (since burn in)
+ MPI_LearnPropose = T
+ #can set a value of converge at which to stop updating covariance (so that it becomes rigorously Markovian)
+ #e.g. MPI_R_StopProposeUpdate = 0.4 will stop updating when (variance of chain means)/(mean of variances) < 0.4
+ MPI_R_StopProposeUpdate = 0
+ 
+ #If have covmat, R to reach before updating proposal density (increase if covmat likely to be poor)
+ #Only used if not varying new parameters that are fixed in covmat
+ MPI_Max_R_ProposeUpdate = 2
+ #As above, but used if varying new parameters that were fixed in covmat
+ MPI_Max_R_ProposeUpdateNew = 30
+ 
+ #if blank this is set from system clock
+ rand_seed = 
+ 
+ #If true, generate checkpoint files and terminated runs can be restarted using exactly the same command
+ #and chains continued from where they stopped
+ #With checkpoint=T note you must delete all chains/file_root.* files if you want new chains with an old file_root
+ checkpoint = T
+ 
+ 
+ #CAMB parameters
+ #If we are including tensors
+ compute_tensors = F
+ #Initial power spectrum amplitude point (Mpc^{-1})
+ pivot_k = 0.05
+ #If using tensors, enforce n_T = -A_T/(8A_s)
+ inflation_consistency = F
+ 
+ #Whether the CMB should be lensed (slows a lot unless also computing matter power)
+ CMB_lensing = T
+ #increase accuracy_level to run CAMB on higher accuracy
+ #(default is about 0.3%, accuracy_level=2 around 0.1% at high l)
+ accuracy_level = 1
+ l_accuracy_level = 1
+ l_sample_level = 1
+ camb_compute_every_l = F
+ 
+ #If action = 1
+ redo_likelihoods = T
+ redo_theory = F
+ redo_cls = F
+ redo_pk = F
+ redo_skip = 0
+ redo_outroot = 
+ redo_thin = 1
+ redo_add = F
+ redo_from_text = F
+ #If large difference in log likelihoods may need to offset to give sensible weights
+ #for exp(difference in likelihoods)
+ redo_likeoffset =  0
+ 
+ #parameter start center, min, max, start width, st. dev. estimate
+ param[omegabh2] = 0.0223 0.005 0.1 0.001 0.001
+ param[omegadmh2] = 0.105 0.01 0.99 0.01 0.01
+ param[theta] = 1.04 0.5 10 0.002 0.002
+ param[tau] = 0.09 0.01 0.8 0.03 0.03
+ 
+ param[omegak] = 0 0 0 0 0
+ param[fnu] = 0 0 0 0 0
+ param[w] = -1 -1 -1 0 0
+ 
+ param[ns] = 0.95 0.5 1.5 0.02 0.01
+ param[nt] = 0 0 0 0 0
+ param[nrun] = 0 0 0 0 0
+ 
+ #log[10^10 A_s]
+ param[logA] = 3 2.7 4 0.01 0.01
+ param[r] = 0 0 0 0 0
+ #SZ amplitude, as in WMAP analysis
+ param[asz]= 1 0 2 0.4 0.4
diff -r -c -b -B -N cosmomc/source/settings.F90 cosmomc_addon/source/settings.F90
*** cosmomc/source/settings.F90	1970-01-01 01:00:00.000000000 +0100
--- cosmomc_addon/source/settings.F90	2009-10-27 18:29:48.013877674 +0100
***************
*** 0 ****
--- 1,200 ----
+ module settings
+   use AMLutils
+   use Random
+   use IniFile
+   use ParamNames
+   implicit none
+ 
+   real :: AccuracyLevel = 1.
+ !addon
+   real :: lAccuracyLevel = 1.
+   real :: lSampleLevel = 1.
+   logical :: CambComputeEveryl = .false.
+ !end addon
+   !Set to >1 to use CAMB etc on higher accuracy settings. 
+   !Does not affect MCMC (except making it all slower)
+ 
+ !num_norm is number of calibration and normalization parameters (fast)
+ !         should be 2 or larger (scale for the scalar Cl, and the T/S ratio
+ !num_initpower is the number of initial power parameters
+ !num_hard is the number of 'hard' parameters
+ !num_freq_params are parameters for frequency-dependant part of CMB signal
+ !                 by default just one, an SZ amplitude
+ !num_nuisance_params is number of nuisance parameters used internally by data likelihoods
+ !                    (e.g. beam uncertainty modes, etc, specific to dataset)
+ 
+   integer, parameter :: num_hard =7 
+   integer, parameter :: num_initpower = 3 
+   integer, parameter :: num_freq_params = 1
+   integer, parameter :: num_norm = 2 + num_freq_params 
+   integer, parameter :: num_nuisance_params= 0
+ 
+   logical :: use_fast_slow = .false.
+     !Set to false if using a slow likelihood function so no there's point is treating
+     !'fast' parameters differently (in fact, doing so will make performance worse)
+ 
+   Type(TParamNames) :: NameMapping
+ 
+   integer :: oversample_fast = 0
+   integer, parameter :: sampling_metropolis = 1, sampling_slice = 2, sampling_fastslice =3, &
+          sampling_slowgrid = 4,  sampling_multicanonical = 5,  sampling_wang_landau = 6
+ 
+   integer :: sampling_method = sampling_metropolis
+  
+   !scale of the proposal distribution in units of the posterior standard deviation
+   real    :: propose_scale  = 2.4 
+ 
+ !The rest are set up automatically
+ 
+   real, parameter :: cl_norm = 1e-10 !units for As
+ 
+   logical, parameter ::  generic_mcmc= .false. 
+     !set to true to not call CAMB, etc.
+     !write GenericLikelihoodFunction in calclike.f90   
+ 
+   character(LEN=1024) :: DataDir='data/';
+ 
+   integer, parameter :: num_fast_params = num_initpower + num_norm + num_nuisance_params
+ 
+   integer, parameter :: num_params = num_norm + num_initpower + num_hard + num_nuisance_params
+   integer, parameter :: num_real_params = num_norm + num_initpower + num_hard 
+   integer, parameter :: index_initpower = num_hard+1
+   integer, parameter :: index_norm = index_initpower + num_initpower
+   integer, parameter :: index_nuisance = index_norm  + num_norm
+   integer, dimension(:), allocatable :: params_used,fast_params_used
+   integer num_params_used, num_fast, num_slow, nuisance_params_used
+ 
+   integer :: num_threads = 0
+   integer :: instance = 0
+ !addon
+   integer :: instance_shift = 0
+ !end addon
+   integer :: MPIchains = 1, MPIrank = 0
+ 
+   logical :: Use_LSS = .true.
+ 
+   integer :: logfile_unit  = 0
+   integer :: outfile_handle = 0 
+   integer :: indepfile_handle = 0
+   integer :: slow_proposals = 0
+   integer :: output_lines = 0
+ 
+   real, parameter :: logZero = 1e30
+   character (LEN =120) :: FileChangeIni = '', FileChangeIniAll = ''
+ 
+ 
+ contains
+ 
+   function ReadIniFileName(Ini,key) result (filename)
+    Type(TIniFile) :: Ini
+    character(LEN=*), intent(in) :: Key
+    character(LEN=Ini_max_string_len) :: filename
+    
+    filename = Ini_Read_String_File(Ini, key)
+    call StringReplace('%DATASETDIR%',DataDir,filename)
+ 
+   end function ReadIniFileName
+ 
+  subroutine CheckParamChangeF(F)
+    character(LEN=*), intent(in) ::  F
+    logical bad, doexit
+ 
+    if (F /= '') then
+ 
+        call Ini_Open(F, tmp_file_unit, bad, .false.)
+        if (bad) return
+        Ini_fail_on_not_found = .false.
+        doexit = (Ini_Read_Int('exit',0) == 1) 
+        FeedBack = Ini_Read_Int('feedback',Feedback)
+        num_threads = Ini_Read_Int('num_threads',num_threads)
+        call Ini_Close
+        if (F== FileChangeIni) call DeleteFile(FileChangeini)
+        if (doexit) stop
+ 
+    end if
+ 
+  end subroutine CheckParamChangeF
+ 
+  subroutine CheckParamChange
+ 
+    call CheckParamChangeF(FileChangeIni)
+    if (FileChangeIni/=FileChangeIniAll) call CheckParamChangeF(FileChangeIniAll)
+ 
+  end subroutine CheckParamChange
+ 
+   subroutine ReadVector(aname, vec, n)
+    character(LEN=*), intent(IN) :: aname
+    integer, intent(in) :: n
+    real, intent(out) :: vec(n)
+    integer j
+ 
+    if (Feedback > 0) write(*,*) 'reading: '//trim(aname)
+ 
+    call OpenTxtFile(aname, tmp_file_unit)
+ 
+    do j=1,n
+       read (tmp_file_unit,*, end = 200) vec(j)
+    end do
+ 
+ 
+     close(tmp_file_unit)
+     return
+ 
+  200 write (*,*) 'vector file '//trim(aname)//' is the wrong size'
+      stop
+ 
+  end subroutine ReadVector
+ 
+  subroutine WriteVector(aname, vec, n)
+    character(LEN=*), intent(IN) :: aname
+    integer, intent(in) :: n
+    real, intent(in) :: vec(n)
+    integer j
+   
+    call CreateTxtFile(aname, tmp_file_unit)
+ 
+    do j=1,n
+       write (tmp_file_unit,'(1E15.6)') vec(j)
+    end do
+ 
+    close(tmp_file_unit)
+   
+  end subroutine WriteVector
+ 
+ 
+  subroutine ReadMatrix(aname, mat, m,n)
+    character(LEN=*), intent(IN) :: aname
+    integer, intent(in) :: m,n
+    real, intent(out) :: mat(m,n)
+    integer j,k
+    real tmp
+ 
+    if (Feedback > 0) write(*,*) 'reading: '//trim(aname)
+    call OpenTxtFile(aname, tmp_file_unit)
+ 
+    do j=1,m
+       read (tmp_file_unit,*, end = 200, err=100) mat(j,1:n)
+    end do
+    goto 120
+ 
+ 100 rewind(tmp_file_unit)  !Try other possible format
+    do j=1,m 
+     do k=1,n
+       read (tmp_file_unit,*, end = 200) mat(j,k)
+     end do
+    end do
+ 
+ 120 read (tmp_file_unit,*, err = 150, end =150) tmp
+    goto 200
+ 
+ 150 close(tmp_file_unit)
+     return
+ 
+  200 write (*,*) 'matrix file '//trim(aname)//' is the wrong size'
+      stop
+ 
+  end subroutine ReadMatrix
+ 
+ 
+ end module settings
+ 
